/*
 * CS560: Systems
 * Rich Wolski
 * 	modified from CS460 -- Jim Plank
 *      modified for ESIAL by Martin Quinson.
 * 
 * phil_naive.c -- Naive solution to Dining philosophers
 */


#include <stdio.h>
#include <pthread.h>
#include "philosophes.h"

typedef struct sticks {
  pthread_mutex_t **lock;
} Sticks;

Sticks *pp;

void pickup(int id, int count) {
  pthread_mutex_lock(pp->lock[id]);       /* lock up left stick */
  pthread_mutex_lock(pp->lock[(id+1)%count]); /* lock up right stick */ 
}

void putdown(int id, int count) {
  pthread_mutex_unlock(pp->lock[(id+1)%count]); /* unlock right stick */ 
  pthread_mutex_unlock(pp->lock[id]);  /* unlock left stick */
}

void initialize_data(int count) {
  int i;

  pp = (Sticks *) malloc(sizeof(Sticks));

  pp->lock = (pthread_mutex_t **) malloc(sizeof(pthread_mutex_t *)*count);
  if (pp->lock == NULL) { perror("malloc"); exit(1); }
   
  for (i = 0; i < count; i++) {
    pp->lock[i] = (pthread_mutex_t *) malloc(sizeof(pthread_mutex_t));
    if (pp->lock[i] == NULL) { perror("malloc"); exit(1); }
  }
  for (i = 0; i < count; i++) {
    pthread_mutex_init(pp->lock[i], NULL);
  }
}
